# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from jasper_report_user_analysis import JasperDataParser
from jasper_reports import jasper_report
import pooler
import time, datetime
import base64
import os

class jasper_user_analysis(JasperDataParser.JasperDataParser):
    def __init__(self, cr, uid, ids, data, context):
        super(jasper_user_analysis, self).__init__(cr, uid, ids, data, context)

    def generate_data_source(self, cr, uid, ids, data, context):
        return 'records'

    def generate_parameters(self, cr, uid, ids, data, context):
        return {}

    def generate_properties(self, cr, uid, ids, data, context):
        return {}

    def generate_records(self, cr, uid, ids, data, context):
        print data,'afdssgsggsgfs'
        pool= pooler.get_pool(cr.dbname)
        result=[]
        total_hours={}

        if 'form' in data:
            user_ids = data['form']['user_ids']
            from_date = data['form']['from_date']
            to_date = data['form']['to_date']
        else:
            user_ids=ids
#        wiz_obj = pool.get('user.analysis').browse(cr, uid,[1])
#        print dir(wiz_obj)
##        user_ids = wiz_obj.user_ids
#        from_date = wiz_obj.from_date
#        to_date = wiz_obj.to_date

        if user_ids == []: user_ids = pool.get('res.users').search(cr, uid, [])
        task_work_ids = pool.get('project.task.work').search(cr, uid, [('user_id','in',user_ids),('date','>=',from_date),('date','<=',to_date)])
        task_work_objs = pool.get('project.task.work').browse(cr, uid, task_work_ids)
        for task_work in task_work_objs:
            data={
                    'path':os.getcwd(),
                    'project_name': task_work.task_id.project_id.name,
                    'from_date':from_date,
                    'to_date':to_date,
                    'task':task_work.task_id.name,
                    'work':task_work.name,
                    'user':task_work.user_id.name,
                    'date':task_work.date.split(' ')[0],
                    'hours':task_work.hours,
                      }
            result.append(data)
        print result
        result = sorted(result, key=lambda d: (d['user'], d['date'],))
        return result

jasper_report.report_jasper('report.jasper_report_user_print', 'res.users', parser=jasper_user_analysis, )
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
